import { ComponentOptionsMixin } from 'vue';
import { DefineComponent } from 'vue';
import { ExtractPropTypes } from 'vue';
import { PropType } from 'vue';
import { PublicProps } from 'vue';

declare type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;

declare type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};

declare type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: PropType<T[K]>;
        required: true;
    };
};

declare type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};

declare const _default: DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
data: () => never[];
isShowPicker: boolean;
options: () => {};
swipeTime: number;
type: string;
}>, {}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
"update:isShowPicker": (...args: any[]) => void;
"update:anchor": (...args: any[]) => void;
cancel: (...args: any[]) => void;
confirm: (...args: any[]) => void;
}, string, PublicProps, Readonly<ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
data: () => never[];
isShowPicker: boolean;
options: () => {};
swipeTime: number;
type: string;
}>>> & {
onCancel?: ((...args: any[]) => any) | undefined;
onConfirm?: ((...args: any[]) => any) | undefined;
"onUpdate:isShowPicker"?: ((...args: any[]) => any) | undefined;
"onUpdate:anchor"?: ((...args: any[]) => any) | undefined;
}, {
swipeTime: number;
options: Partial<PickerOptions>;
type: string;
data: PickData;
isShowPicker: boolean;
}, {}>;
export default _default;

declare type EmitKey = 'update:isShowPicker' | 'update:anchor' | 'cancel' | 'confirm';

export declare type NormalData = Record<PropertyKey, unknown> | string | number;

export declare type OriginData = Array<NormalData>;

export declare type PickData = OriginData | Array<OriginData>;

export declare type PickerEmit = (event: EmitKey, ...args: unknown[]) => void;

export declare interface PickerOptions {
    cancelClass: string;
    confirmClass: string;
    titleClass: string;
    cancelColor: string;
    confirmColor: string;
    titleColor: string;
    cancelText: string;
    confirmText: string;
    titleText: string;
}

export declare interface PickerProps {
    data: PickData;
    isShowPicker: boolean;
    anchor: number | Array<number>;
    options?: Partial<PickerOptions>;
    showKey?: string | Array<string>;
    swipeTime?: number;
    type: string;
}

export declare interface PickerSelectItems {
    item: Array<NormalData>;
    anchor: Array<number>;
}

declare interface Props {
    data?: PickData;
    isShowPicker: boolean;
    options?: Partial<PickerOptions>;
    anchor: number | Array<number>;
    showKey?: string | Array<string>;
    swipeTime?: number;
    type?: string;
}

export { }
